"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var selectable_1 = require('./decorators/selectable');
var forms_1 = require('@angular/forms');
var ng2_material_dropdown_1 = require('ng2-material-dropdown');
var accessor_1 = require('./accessor');
var CUSTOM_SELECT_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return Ng2Select; }),
    multi: true
};
var Ng2Select = (function (_super) {
    __extends(Ng2Select, _super);
    function Ng2Select() {
        _super.apply(this, arguments);
        this.options = [];
        this.multiple = false;
        this.onChange = new core_1.EventEmitter();
    }
    Ng2Select.prototype.getSelectedValue = function () {
        if (this.multiple && this.selected.length === 1) {
            return this.displayValue(this.selected[0]);
        }
        else {
            var index = this.options.indexOf(this.value);
            return index >= 0 ? this.displayValue(this.options[index]) : undefined;
        }
    };
    Ng2Select.prototype.displayValue = function (item) {
        return this.displayBy ? item[this.displayBy] : item;
    };
    Object.defineProperty(Ng2Select.prototype, "placeholderDisplay", {
        get: function () {
            if (this.multiple && this.selected.length > 1) {
                return this.selected.length + " items selected";
            }
            else {
                return this.getSelectedValue() || this.placeholder;
            }
        },
        enumerable: true,
        configurable: true
    });
    Ng2Select.prototype.isSelected = function (item) {
        if (this.multiple) {
            return this.selected.indexOf(item) >= 0;
        }
        else {
            return this.value === item;
        }
    };
    Ng2Select.prototype.ngOnInit = function () {
        var _this = this;
        var state = this.dropdown.state;
        state.onItemClicked.subscribe(function (item) {
            if (_this.multiple) {
                _this.toggle(item.value);
            }
            _this.value = _this.multiple ? _this.selected : _this.options.indexOf(item.value);
            _this.onChange.emit(_this.value);
        });
        this.dropdown.onShow.subscribe(function () {
            if (!_this.value) {
                return;
            }
            var index = _this.findIndexValue(_this.value);
            var item = _this.dropdown.menu.items.toArray()[index];
            _this.dropdown.state.select(item, false);
        });
        console.log(this.selected);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Ng2Select.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], Ng2Select.prototype, "options", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Ng2Select.prototype, "displayBy", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Ng2Select.prototype, "identifyBy", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Ng2Select.prototype, "multiple", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], Ng2Select.prototype, "onChange", void 0);
    __decorate([
        core_1.ViewChild(ng2_material_dropdown_1.Ng2Dropdown), 
        __metadata('design:type', Object)
    ], Ng2Select.prototype, "dropdown", void 0);
    Ng2Select = __decorate([
        core_1.Component({
            selector: 'ng2-select',
            providers: [CUSTOM_SELECT_VALUE_ACCESSOR],
            styles: [require('./style.scss').toString()],
            template: require('./template.html')
        }),
        selectable_1.Selectable(), 
        __metadata('design:paramtypes', [])
    ], Ng2Select);
    return Ng2Select;
}(accessor_1.SelectAccessor));
exports.Ng2Select = Ng2Select;
//# sourceMappingURL=ng2-select.js.map